There are
n
gas stations along a circular route, where the amount of gas at the i
th
station is gas[i]
.You have a car with an unlimited gas tank and it costs
cost[i]
of gas to travel from the i
th
station to its next (i + 1)
th
station. You begin the journey with an empty tank at one of the gas stations.Given two integer arrays
gas
and cost
, return the starting gas station's index if you can travel around the circuit once in the clockwise direction, otherwise return -1
. If there exists a solution, it is guaranteed to be uniqueExample 1:
Input: gas = [1,2,3,4,5], cost = [3,4,5,1,2] Output: 3 Explanation: Start at station 3 (index 3) and fill up with 4 unit of gas. Your tank = 0 + 4 = 4 Travel to station 4. Your tank = 4 - 1 + 5 = 8 Travel to station 0. Your tank = 8 - 2 + 1 = 7 Travel to station 1. Your tank = 7 - 3 + 2 = 6 Travel to station 2. Your tank = 6 - 4 + 3 = 5 Travel to station 3. The cost is 5. Your gas is just enough to travel back to station 3. Therefore, return 3 as the starting index.
Example 2:
Input: gas = [2,3,4], cost = [3,4,3] Output: -1 Explanation: You can't start at station 0 or 1, as there is not enough gas to travel to the next station. Let's start at station 2 and fill up with 4 unit of gas. Your tank = 0 + 4 = 4 Travel to station 0. Your tank = 4 - 3 + 2 = 3 Travel to station 1. Your tank = 3 - 3 + 3 = 3 You cannot travel back to station 2, as it requires 4 unit of gas but you only have 3. Therefore, you can't travel around the circuit once no matter where you start.
Constraints:
n == gas.length == cost.length
1 <= n <= 10^5
0 <= gas[i], cost[i] <= 10^4
풀이
효성
n^2인거 예상은 했지만 고집부려서 시간 초과당한 거 결국 봤네요 ^^..
var canCompleteCircuit = function(gas, cost) { const n = gas.length; let maxDiffIdxList = []; for(let i = 0; i < n; i++) { const diff = gas[i] - cost[i]; if(diff >= 0) { maxDiffIdxList.push(i); } } for(let i = 0; i < maxDiffIdxList.length; i++) { const curIdx = maxDiffIdxList[i]; const newGas = gas.slice(curIdx, n).concat(gas.slice(0, curIdx)); const newCost = cost.slice(curIdx, n).concat(cost.slice(0, curIdx)); if(canGo(newGas, newCost)) { return curIdx; } } return -1; }; function canGo(gas, cost) { const n = gas.length; let curTank = gas[0]; for(let i = 0; i < n; i++) { curTank -= cost[i]; if(curTank < 0) { return false; } curTank += gas[i + 1]; } return curTank < 0 ? false : true; }
참고한 풀이
(엇 저희 이 문제 풀었네요..ㅎㅎ.. 복습 차원으로 낸 걸루..)
var canCompleteCircuit = function(gas, cost) { let curTank = 0 let totalTank = 0 let pos = 0; for (let i = 0; i < gas.length; i++) { curTank += gas[i] - cost[i]; totalTank += gas[i] - cost[i]; if (curTank < 0) { curTank = 0; pos = i + 1; } } return totalTank < 0 ? -1 : pos; }
재영
Previous:
110ms (Greedy, 굳이 세부적으로 따지자면 O(3 * N))
After:
78ms (used PrefixSum, O(N))
const canCompleteCircuit = (gas, cost) => { const prefixSumStack = []; let maxValue = -Infinity; let maxValueIndex = 0; let total = 0; for (let i = gas.length - 1; i >= 0; i -= 1) { const diff = gas[i] - cost[i]; total += diff; if (total >= maxValue) { maxValue = total; maxValueIndex = i; } prefixSumStack.push(total); } return prefixSumStack.pop() < 0 ? -1 : maxValueIndex; };